use serde::{Deserialize, Serialize};

#[derive(Serialize, Deserialize)]
pub struct Data {
    batery: Option<Batery>,
    device: Option<Device>,
    driver: Option<Driver>,
    input: Option<Input>,
    output: Option<Output>,
}

#[derive(Serialize, Deserialize)]
pub struct Batery {
    charge: Option<Charge>,
    mrf_date: Option<String>,
    runtime: Option<Runtime>,
    btype: Option<String>,
    voltage: Option<Voltage>,
}

#[derive(Serialize, Deserialize)]
pub struct Charge {
    value: Option<u8>,
    low: Option<u8>,
    warning: Option<u8>,
}

#[derive(Serialize, Deserialize)]
pub struct Runtime {
    value: Option<u32>,
    low: Option<u32>,
}

#[derive(Serialize, Deserialize)]
pub struct Voltage {
    value: Option<f32>,
    nominal: Option<f32>,
}

#[derive(Serialize, Deserialize)]
pub struct Device {
    mfr: Option<String>,
    model: Option<String>,
    serial: Option<String>,
    dtype: Option<String>,
}

#[derive(Serialize, Deserialize)]
pub struct Driver {
    name: Option<String>,
    parameter: Option<Parameter>,
    version: Option<Version>,
}

#[derive(Serialize, Deserialize)]
pub struct Parameter {
    pollfreq: Option<u8>,
    pollinterval: Option<u8>,
    port: Option<String>,
    synchronous: Option<String>,

}

#[derive(Serialize, Deserialize)]
pub struct Version {
    value: Option<String>,
    data: Option<String>,
    internal: Option<String>,
    usb: Option<String>,
}

#[derive(Serialize, Deserialize)]
pub struct Input {
    frecuency: Option<f32>,
    voltage: Option<Voltage>,
}

#[derive(Serialize, Deserialize)]
pub struct Output {
    frecuency: Option<f32>,
    voltage: Option<f64>,
}

#[derive(Serialize, Deserialize)]
pub struct Ups {
    beeper_status: Option<String>,
    delay: Option<Delay>,
    load: Option<u8>,
    mfr: Option<String>,
    model: Option<String>,
    productid: Option<String>,
    realpower_nominal: Option<u16>,
    serial: Option<String>,
    status: Option<String>,
    test_result: Option<String>,
    timer: Option<Timer>,
    vendorid: Option<String>,
}

#[derive(Serialize, Deserialize)]
pub struct Delay {
    shutdown: Option<u8>,
    start: Option<u8>,
}

#[derive(Serialize, Deserialize)]
pub struct Timer {
    shutdown: Option<i16>,
    start: Option<i16>,
}
